package ru.ulstu.extractor.ts.creator;

import org.springframework.stereotype.Component;
import ru.ulstu.extractor.commit.service.CommitService;
import ru.ulstu.extractor.gitrepository.model.FileChange;
import ru.ulstu.extractor.gitrepository.service.GitRepositoryService;
import ru.ulstu.extractor.model.Commit;
import ru.ulstu.extractor.ts.model.TimeSeries;
import ru.ulstu.extractor.ts.model.TimeSeriesType;
import ru.ulstu.extractor.ts.service.TimeSeriesService;

import java.util.ArrayList;
import java.util.List;

@Component
public class FileTS extends AbstractTimeSeriesCreator {
    private final TimeSeriesService timeSeriesService;
    private final GitRepositoryService gitRepositoryService;
    private final CommitService commitService;

    public FileTS(TimeSeriesService timeSeriesService, GitRepositoryService gitRepositoryService, CommitService commitService) {
        this.timeSeriesService = timeSeriesService;
        this.gitRepositoryService = gitRepositoryService;
        this.commitService = commitService;
    }

    @Override
    public List<TimeSeries> getTimeSeries(Integer repositoryId, String branchName) {
//        findSum(repositoryId,branchName);
        return new ArrayList<>();
//        return Collections.singletonList(
//                new TimeSeries(
//                        String.format("",
//                                gitRepositoryService.findById(repositoryId).getName(),
//                                branchName,
//                                getTimeSeriesType().getDescription()),
//                        getTimeSeriesType(),
//                        )
//                )
//        )
    }

    @Override
    public TimeSeriesService getTimeSeriesService() {
        return timeSeriesService;
    }

    @Override
    public TimeSeriesType getTimeSeriesType() {
        return TimeSeriesType.FILES;
    }

    public void findSum(Integer repositoryId, String branchName) {
        List<Commit> commits = new ArrayList<>(commitService.findByRepositoryIdAndName(repositoryId, branchName));
        int value = 0;
        for (Commit commit : commits) {
            for (FileChange fileChange : commit.getFileChanges()) {
                if ((fileChange.getAdded() != null) && (fileChange.getAdded())) {
                    value = +1;
                }
                if ((fileChange.getRemoved() != null) && (fileChange.getRemoved())) {
                    value = -1;
                }
            }
            System.out.println(value);
        }
    }
}
